$MODID51                                ; ENABLE TB51
$IC(MACROS51)                           ; ENABLE MACRO

          ORG           0000H
          SJMP          MAIN            ; bypass Vector Table

; -- ISR for Timer 1
          ORG           001BH           ; Timer 1 interupt vector table
          MJMP          ISR_T1          ; jump to ISR

; -- main program after vector space
          ORG           0030H
MAIN:
          MOV           R0, #0          ; 50 ms counter
          MOV           R2, #1          ; second
          MOV           R3, #5          ; minute
          MOV           R1, #44H        ; 44H, 45H, 46H AND 47H ARE SEGMENT MEMORIES

          MOV           R4, #0          ; toggle flag

          MOV           DPTR,#200H      ; LOAD DATA POINTER
          
          MOV           TMOD,  #10H     ; timer 1, mod 1
          MOV           TL1,   #03H     ; the low byte of B403h
          MOV           TH1,   #0B4H     ; the high byte of B403h
          MOV           IE,    #88H     ; IE = 10001000 enable timer 1 interupt
          SETB          TR1             ; start timer 1

; -- Etc
          MOV           SG1,   #Dig1
          MOV           SG2,   #Dig6
          MOV           SG3,   #Dig0
          MOV           SG4,   #Dig5

          SETCTRL     0
          SETCTRL     1
          SETCTRL     2
          SETCTRL     3
          SELECT        SEG
BACK:     ACALL         REFRESH7SEG
          CJNE          R0, #20, BACK
          MOV           R0, #0
          ACALL         TOGGLE
          INC           R2
          CJNE          R2, #6, BACK
;---------------------------- changing the minute ---------------------------
          MOV           R2, #0         ; zeroing the second
          INC           R3
          MOV           A, R3
          MOV           B, #10
          DIV           AB             ; divide by 10
          MOVMEM        A,@A+DPTR
          MOV           R1, #46H        ; 44H, 45H, 46H AND 47H ARE SEGMENT MEMORIES
          MOV           @R1,A
          MOV           A, B
          MOV           R1, #47H
          MOVMEM        A,@A+DPTR
          MOV           @R1,A
          SJMP          BACK

; -- Toggle the middle dot
TOGGLE:
            PUSH          0E0H
            PUSH          PSW
            SETCTRL       0
            SETCTRL       1
            SETCTRL       2
            SETCTRL       3
            MOV           A, SG2
            CJNE          R4, #0, L1
            ANL           A, #7FH
            MOV           R4, #1
            SJMP          GETA
L1:         ORL           A, #80H
            MOV           R4, #0

GETA:       MOV           DAT, A
            MOV           SG2, A
            CLRCTRL       2
            SETCTRL       2
            POP           PSW
            POP           0E0H
            RET
            
; -- refresh 7 segment
REFRESH7SEG:
            CLRCTRL     3
            MOV         A,SG1
            MOV         DAT,A
            DELAY       10
            SETCTRL     3

            CLRCTRL     2
            MOV         A,SG2
            MOV         DAT,A
            DELAY       10
            SETCTRL     2

            CLRCTRL      1
            MOV          A,SG3
            MOV          DAT,A
            DELAY        10
            SETCTRL      1

            CLRCTRL      0
            MOV          A,SG4
            MOV          DAT,A
            DELAY        10
            SETCTRL      0
            RET
            
; -- Timer 1 ISR
ISR_T1:
          CLR           TR1             ; stop timer 0
          INC           R0              ; increase R0
          MOV           TL1,   #003H     ; the low byte of B403h
          MOV           TH1,   #0B4H     ; the high byte of B403h
          SETB          TR1             ; starts timer 1
          RETI
ORG 200H
TABLE1: DB  3FH, 30H, 6DH, 79H, 72H, 5BH, 5FH, 31H, 7FH, 7BH
END
